<template>
  <validation-observer v-slot="{ handleSubmit }">
    <form @submit.prevent="handleSubmit(calculate.bind(null, form))" class="mb-6">
      <div class="columns is-desktop is-centered">
        <div class="column is-2-desktop">
          <validation-provider
            v-slot="{ errors, valid }"
            name="Data do investimento"
            rules="required"
          >
            <gw-field
              label="Data do investimento"
              label-position="inside"
              :type="{ 'is-danger': errors[0], 'is-success': valid }"
              :message="errors">
              <gw-datepicker v-model="form.investmentDate" />
            </gw-field>
          </validation-provider>
        </div>
        <div class="column is-2-desktop">
          <validation-provider
            v-slot="{ errors, valid }"
            name="Data atual"
            rules="required"
          >
            <gw-field
              label="Data atual"
              label-position="inside"
              :type="{ 'is-danger': errors[0], 'is-success': valid }"
              :message="errors">
              <gw-datepicker
                v-model="form.currentDate" />
            </gw-field>
          </validation-provider>
        </div>
        <div class="column is-2-desktop">
          <validation-provider
            v-slot="{ errors, valid }"
            name="Taxa do CDB"
            rules="required|min_value:100"
          >
            <gw-field
              label="Taxa do CDB"
              label-position="inside"
              :type="{ 'is-danger': errors[0], 'is-success': valid }"
              :message="errors">
              <div class="control">
                <gw-percentage
                  v-model="form.cdbRate"
                  placeholder="000,00%"
                  maxlength="6"
                  :has-counter="false"/>
              </div>
            </gw-field>
          </validation-provider>
        </div>
        <div class="column is-2-desktop">
          <validation-provider
            v-slot="{ errors, valid }"
            name="Valor base"
            rules="required|min_value:1000"
          >
            <gw-field
              label="Valor base"
              label-position="inside"
              :type="{ 'is-danger': errors[0], 'is-success': valid }"
              :message="errors">
              <div class="control">
                <gw-currency
                  v-model="form.baseValue"
                  placeholder="R$ 1000,00"
                  maxlength="6"
                  :has-counter="false"/>
              </div>
            </gw-field>
          </validation-provider>
        </div>
        <div class="column is-narrow page-cdb__form-button">
          <gw-field>
            <p class="control">
              <button
                class="button is-primary is-rounded"
                :class="{
                  'is-loading': loading,
                }"
                :disabled="loading">Calcular</button>
            </p>
          </gw-field>
        </div>
      </div>
    </form>
  </validation-observer>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';
import { ValidationObserver, ValidationProvider } from 'vee-validate';
import GwField from '@/components/gw-field/GwField.vue';
import GwDatepicker from '@/components/gw-datepicker/GwDatepicker.vue';
import GwPercentage from '@/components/gw-percentage/GwPercentage.vue';
import GwCurrency from '@/components/gw-currency/GwCurrency.vue';

const { mapState, mapActions } = createNamespacedHelpers('cdbCalculate');

export default {
  name: 'GwCdbCalculateFilters',
  data() {
    return {
      form: {
        currentDate: new Date(),
      },
    };
  },
  computed: {
    ...mapState([
      'loading',
    ]),
  },
  methods: {
    ...mapActions([
      'calculate',
    ]),
  },
  components: {
    ValidationObserver,
    ValidationProvider,
    GwField,
    GwDatepicker,
    GwCurrency,
    GwPercentage,
  },
};
</script>

<style lang="scss" scoped>
  .page-cdb{
    &__form-button{
      padding: 1rem 0;
    }
  }
</style>
